Uunf — Unicode text normalization for OCaml
-------------------------------------------------------------------------------
Release 1.0.0

Uunf is an OCaml library for normalizing Unicode text. It supports all
Unicode [normalization forms][1]. The library is independent from any
IO mechanism or Unicode text data structure and it can process text
without a complete in-memory representation.

Uunf has no dependency. It may optionally depend on [Uutf][2] for
support on OCaml UTF-X encoded strings. It is distributed under the
BSD3 license.

[1]: http://www.unicode.org/reports/tr15/
[2]: http://erratique.ch/software/uutf

Home page: http://erratique.ch/software/uunf  
Contact: Daniel Bünzli `<daniel.buenzl i@erratique.ch>`


## Installation

Uunf can be installed with `opam`:

    opam install uunf
    opam install uutf uunf # for support on OCaml UTF-X encoded strings

If you don't use `opam` consult the [`opam`](opam) file for build
instructions and a complete specification of the dependencies.


## Documentation

The documentation and API reference is automatically generated by
`ocamldoc` from the interfaces. It can be consulted [online][3] and
there is a generated version in the `doc` directory of the
distribution.

[3]: http://erratique.ch/software/uunf/doc/


## Sample programs

Sample programs are located in the `test` directory of the
distribution. They can be built with:

    ocamlbuild -use-ocamlfind test/tests.otarget

The resulting binaries are in `_build/test` :

- `test.native` tests the library with the Unicode Normalization Test
  file available from:

  http://www.unicode.org/Public/%%UNICODEVERSION%%/ucd/NormalizationTest.txt

  Nothing should fail.

- `test_string.native` tests the UTF-X OCaml string support.

- `unftrip.native` inputs Unicode text on `stdin` and rewrites it on
  `stdout` in a given normalization form. Invoke with `-help` for more
  information. Depends on [`uutf`](http://erratique.ch/software/uutf).
